import shutil
import os
import signal
import colorama
import time
from colorama import Fore, Back, Style
import readchar # muss extra installiert werden mit: pip install readchar
import AsciiBildConverter as abc


thread_Pause = False
thread_kill = False

# Übergabe der eingegebenen Farben (für globale Variable)
def AbbruchFarbeZuweisung (farbe1, farbe2):
    global abbruchHinFarbe
    global abbruchVorFarbe
    abbruchHinFarbe = farbe1
    abbruchVorFarbe = farbe2

def Abbruch(signum, frame):
    global thread_Pause
    global thread_kill
    thread_Pause = True
    time.sleep(0.2)
    text = "\nSTRG-C wurde gedrückt. Willst du wirklich abbrechen? Drücke j/n (für Ja/Nein)."
    print(Back.BLACK + Fore.RED + text, flush=True)
    time.sleep(0.2)
    antwort = readchar.readkey().lower()
    if antwort == 'j':
        thread_kill = True # extra Thread sollte vor Programmende gekillt werden, da sonst die Anaconda (manchmal) verbuggt ist
        abc.BildFreigeben()
        time.sleep(0.1)
        print("")
        # Fehlerabfang, falls der Ordner noch nicht erstellt wurde
        if os.path.exists('Bildercache'):
            shutil.rmtree('Bildercache') # Löscht kompletten Ordner

        print(Style.RESET_ALL)
        exit(1)
    else:
        thread_Pause = False
        # Fehlerabfang, falls am Anfang (vor Farbauswahl) STRG+C gedrückt wird
        try:
            print(getattr(Fore, abbruchHinFarbe) + getattr(Back, abbruchVorFarbe), end="\r") # für Hintergrundfarbe und Zeichenfarbe, print(Style.RESET_ALL) für Reset
        except Exception:
            print(Style.RESET_ALL)

        print("", end="\r", flush=True) # Flush fixt ein Problem mit sleep
        print(" " * len(text), end="", flush=True) # Löscht gedruckte Zeile
        print("    ", end="\r", flush=True)

def Abbruchsignal():
    signal.signal(signal.SIGINT, Abbruch)
